// Copyright 2024 SquareBlock Inc. All Rights Reserved.
// Author: tianlei.richard@qq.com (tianlei.richard)

#include "common.h"

template <int d>
std::vector<Eigen::Vector<double, d>>
apply_transform(const TransformMatrix &mtx,
                const std::vector<Eigen::Vector<double, d>> &points) {
  std::vector<Eigen::Vector<double, d>> res{};
  for (const auto &p : points) {
    res.push_back((mtx * p.homogeneous()).hnormalized());
  }
  return res;
}

template <int d>
void apply_transform_in_place(const TransformMatrix &mtx,
                              std::vector<Eigen::Vector<double, d>> &points) {
  for (auto &p : points) {
    p = (mtx * p.homogeneous()).hnormalized();
  }
}
